Index: branches/1.0/src/de/readme.txt
===================================================================
--- branches/1.0/src/de/readme.txt	(revision 35)
+++ branches/1.0/src/de/readme.txt	(revision 36)
@@ -64,2 +64,6 @@
    - enable usage of high memory 
      (fixes crash with VIRTUALADDRESSLIMIT > 2048)
+     
+ v1.0 beta1:
+   - fix makefile.kmk
+   - new icon
Index: branches/1.0/src/de/uni.rc
===================================================================
--- branches/1.0/src/de/uni.rc	(revision 35)
+++ branches/1.0/src/de/uni.rc	(revision 36)
@@ -12,135 +12,135 @@
 BEGIN
     PORT_ID_1               "UNI1"
-    PORT_DESC_1             "UNI port"
+    PORT_DESC_1             "UNI Anschluss"
     PORT_ID_2               "UNI2"
-    PORT_DESC_2             "UNI port"
+    PORT_DESC_2             "UNI Anschluss"
     PORT_ID_3               "UNI3"
-    PORT_DESC_3             "UNI port"
+    PORT_DESC_3             "UNI Anschluss"
     PORT_ID_4               "UNI4"
-    PORT_DESC_4             "UNI port"
+    PORT_DESC_4             "UNI Anschluss"
     PORT_ID_5               "UNI5"
-    PORT_DESC_5             "UNI port"
+    PORT_DESC_5             "UNI Anschluss"
     PORT_ID_6               "UNI6"
-    PORT_DESC_6             "UNI port"
+    PORT_DESC_6             "UNI Anschluss"
     PORT_ID_7               "UNI7"
-    PORT_DESC_7             "UNI port"
+    PORT_DESC_7             "UNI Anschluss"
     PORT_ID_8               "UNI8"
-    PORT_DESC_8             "UNI port"
+    PORT_DESC_8             "UNI Anschluss"
     PORT_ID_9               "UNI9"
-    PORT_DESC_9             "UNI port"
+    PORT_DESC_9             "UNI Anschluss"
     PORT_ID_10              "UNI10"
-    PORT_DESC_10            "UNI port"
+    PORT_DESC_10            "UNI Anschluss"
     PORT_ID_11              "UNI11"
-    PORT_DESC_11            "UNI port"
+    PORT_DESC_11            "UNI Anschluss"
     PORT_ID_12              "UNI12"
-    PORT_DESC_12            "UNI port"
+    PORT_DESC_12            "UNI Anschluss"
     PORT_ID_13              "UNI13"
-    PORT_DESC_13            "UNI port"
+    PORT_DESC_13            "UNI Anschluss"
     PORT_ID_14              "UNI14"
-    PORT_DESC_14            "UNI port"
+    PORT_DESC_14            "UNI Anschluss"
     PORT_ID_15              "UNI15"
-    PORT_DESC_15            "UNI port"
+    PORT_DESC_15            "UNI Anschluss"
     PORT_ID_16              "UNI16"
-    PORT_DESC_16            "UNI port"
+    PORT_DESC_16            "UNI Anschluss"
     PORT_ID_17              "UNI17"
-    PORT_DESC_17            "UNI port"
+    PORT_DESC_17            "UNI Anschluss"
     PORT_ID_18              "UNI18"
-    PORT_DESC_18            "UNI port"
+    PORT_DESC_18            "UNI Anschluss"
     PORT_ID_19              "UNI19"
-    PORT_DESC_19            "UNI port"
+    PORT_DESC_19            "UNI Anschluss"
     PORT_ID_20              "UNI20"
-    PORT_DESC_20            "UNI port"
+    PORT_DESC_20            "UNI Anschluss"
     PORT_ID_21              "UNI21"
-    PORT_DESC_21            "UNI port"
+    PORT_DESC_21            "UNI Anschluss"
     PORT_ID_22              "UNI22"
-    PORT_DESC_22            "UNI port"
+    PORT_DESC_22            "UNI Anschluss"
     PORT_ID_23              "UNI23"
-    PORT_DESC_23            "UNI port"
+    PORT_DESC_23            "UNI Anschluss"
     PORT_ID_24              "UNI24"
-    PORT_DESC_24            "UNI port"
+    PORT_DESC_24            "UNI Anschluss"
     PORT_ID_25              "UNI25"
-    PORT_DESC_25            "UNI port"
+    PORT_DESC_25            "UNI Anschluss"
     PORT_ID_26              "UNI26"
-    PORT_DESC_26            "UNI port"
+    PORT_DESC_26            "UNI Anschluss"
     PORT_ID_27              "UNI27"
-    PORT_DESC_27            "UNI port"
+    PORT_DESC_27            "UNI Anschluss"
     PORT_ID_28              "UNI28"
-    PORT_DESC_28            "UNI port"
+    PORT_DESC_28            "UNI Anschluss"
     PORT_ID_29              "UNI29"
-    PORT_DESC_29            "UNI port"
+    PORT_DESC_29            "UNI Anschluss"
     PORT_ID_30              "UNI30"
-    PORT_DESC_30            "UNI port"
+    PORT_DESC_30            "UNI Anschluss"
     PORT_ID_31              "UNI31"
-    PORT_DESC_31            "UNI port"
+    PORT_DESC_31            "UNI Anschluss"
     PORT_ID_32              "UNI32"
-    PORT_DESC_32            "UNI port"
+    PORT_DESC_32            "UNI Anschluss"
     PORT_ID_33              "UNI33"
-    PORT_DESC_33            "UNI port"
+    PORT_DESC_33            "UNI Anschluss"
     PORT_ID_34              "UNI34"
-    PORT_DESC_34            "UNI port"
+    PORT_DESC_34            "UNI Anschluss"
     PORT_ID_35              "UNI35"
-    PORT_DESC_35            "UNI port"
+    PORT_DESC_35            "UNI Anschluss"
     PORT_ID_36              "UNI36"
-    PORT_DESC_36            "UNI port"
+    PORT_DESC_36            "UNI Anschluss"
     PORT_ID_37              "UNI37"
-    PORT_DESC_37            "UNI port"
+    PORT_DESC_37            "UNI Anschluss"
     PORT_ID_38              "UNI38"
-    PORT_DESC_38            "UNI port"
+    PORT_DESC_38            "UNI Anschluss"
     PORT_ID_39              "UNI39"
-    PORT_DESC_39            "UNI port"
+    PORT_DESC_39            "UNI Anschluss"
     PORT_ID_40              "UNI40"
-    PORT_DESC_40            "UNI port"
+    PORT_DESC_40            "UNI Anschluss"
     PORT_ID_41              "UNI41"
-    PORT_DESC_41            "UNI port"
+    PORT_DESC_41            "UNI Anschluss"
     PORT_ID_42              "UNI42"
-    PORT_DESC_42            "UNI port"
+    PORT_DESC_42            "UNI Anschluss"
     PORT_ID_43              "UNI43"
-    PORT_DESC_43            "UNI port"
+    PORT_DESC_43            "UNI Anschluss"
     PORT_ID_44              "UNI44"
-    PORT_DESC_44            "UNI port"
+    PORT_DESC_44            "UNI Anschluss"
     PORT_ID_45              "UNI45"
-    PORT_DESC_45            "UNI port"
+    PORT_DESC_45            "UNI Anschluss"
     PORT_ID_46              "UNI46"
-    PORT_DESC_46            "UNI port"
+    PORT_DESC_46            "UNI Anschluss"
     PORT_ID_47              "UNI47"
-    PORT_DESC_47            "UNI port"
+    PORT_DESC_47            "UNI Anschluss"
     PORT_ID_48              "UNI48"
-    PORT_DESC_48            "UNI port"
+    PORT_DESC_48            "UNI Anschluss"
     PORT_ID_49              "UNI49"
-    PORT_DESC_49            "UNI port"
+    PORT_DESC_49            "UNI Anschluss"
     PORT_ID_50              "UNI50"
-    PORT_DESC_50            "UNI port"
+    PORT_DESC_50            "UNI Anschluss"
     PORT_ID_51              "UNI51"
-    PORT_DESC_51            "UNI port"
+    PORT_DESC_51            "UNI Anschluss"
     PORT_ID_52              "UNI52"
-    PORT_DESC_52            "UNI port"
+    PORT_DESC_52            "UNI Anschluss"
     PORT_ID_53              "UNI53"
-    PORT_DESC_53            "UNI port"
+    PORT_DESC_53            "UNI Anschluss"
     PORT_ID_54              "UNI54"
-    PORT_DESC_54            "UNI port"
+    PORT_DESC_54            "UNI Anschluss"
     PORT_ID_55              "UNI55"
-    PORT_DESC_55            "UNI port"
+    PORT_DESC_55            "UNI Anschluss"
     PORT_ID_56              "UNI56"
-    PORT_DESC_56            "UNI port"
+    PORT_DESC_56            "UNI Anschluss"
     PORT_ID_57              "UNI57"
-    PORT_DESC_57            "UNI port"
+    PORT_DESC_57            "UNI Anschluss"
     PORT_ID_58              "UNI58"
-    PORT_DESC_58            "UNI port"
+    PORT_DESC_58            "UNI Anschluss"
     PORT_ID_59              "UNI59"
-    PORT_DESC_59            "UNI port"
+    PORT_DESC_59            "UNI Anschluss"
     PORT_ID_60              "UNI60"
-    PORT_DESC_60            "UNI port"
+    PORT_DESC_60            "UNI Anschluss"
     PORT_ID_61              "UNI61"
-    PORT_DESC_61            "UNI port"
+    PORT_DESC_61            "UNI Anschluss"
     PORT_ID_62              "UNI62"
-    PORT_DESC_62            "UNI port"
+    PORT_DESC_62            "UNI Anschluss"
     PORT_ID_63              "UNI63"
-    PORT_DESC_63            "UNI port"
+    PORT_DESC_63            "UNI Anschluss"
     PORT_ID_64              "UNI64"
-    PORT_DESC_64            "UNI port"
-    PDR_ID_PROPERTIES       "Properties"
+    PORT_DESC_64            "UNI Anschluss"
+    PDR_ID_PROPERTIES       "Eigenschaften"
     ID_NUMBER_OF_DESC_LINES "1"
-    ID_FIRST_DESC_LINES     "UNI port driver"
-    PORT_ERR_TITLE          "Port Driver Error"
-    PORT_HELP_TITLE         "UNI Port Help"
+    ID_FIRST_DESC_LINES     "UNI Anschlusstreiber"
+    PORT_ERR_TITLE          "Anschlusstreiber Fehler"
+    PORT_HELP_TITLE         "UNI Anschlusstreiber Hilfe"
 END
Index: branches/1.0/src/en/readme.txt
===================================================================
--- branches/1.0/src/en/readme.txt	(revision 35)
+++ branches/1.0/src/en/readme.txt	(revision 36)
@@ -1,3 +1,3 @@
-                           eCS (OS/2) Universal Port Driver 
+                           Universal Port Driver for OS/2 (ArcaOS, eCS)
                            Version _VERSION_
                            Build _BUILD_
@@ -39,7 +39,10 @@
    - fixed token replacement logic (diver)
    
- v1.0 beta1:
+ v1.0 alpha4:
    - rebuild with LIBC066.DLL
    - enable usage of high memory 
      (fixes crash with VIRTUALADDRESSLIMIT > 2048)
 
+ v1.0 beta1:
+   - fix makefile.kmk
+   - new icon